# flopc::MP_index_exp Class Reference
[Public interface]

Representation of an expression involving an index. More...

`#include <MP_index.hpp>`

Inheritance diagram for flopc::MP_index_exp:
[legend]
Collaboration diagram for flopc::MP_index_exp:
[legend]

List of all members.

## Public Member Functions
| MP_index_exp (MP_index_base *r)
| For internal use.
| MP_index_exp (int i=0)
| create an index expression from a constant integer.
| MP_index_exp (const Constant &c)
| create an index expression from a Constant
| MP_index_exp (MP_index &i)
| create an index expression from an MP_index.
| MP_index_exp (const SUBSETREF &d)
| create an index expression from a SUBSETREF
| MP_index_exp (const MP_index_exp &other)
| copy constructor from another MP_index_exp
virtual | ~MP_index_exp ()
## Static Public Member Functions
static const MP_index_exp & | getEmpty ()
| Return the unique empty expression.
## Static Private Attributes
static MP_index_exp | Empty

## Detailed Description

Representation of an expression involving an index.

This is one of the main public interface classes. It is used to create complex arrangements of index values.
Index expressions can involve:

- constants
- other indexes
- subset references
- other index expressions.
  There is a unique 'empty' version for use in defaulting extra dimensions.

Definition at line 145 of file MP_index.hpp.

## Constructor & Destructor Documentation

flopc::MP_index_exp::MP_index_exp | ( | MP_index_base * | r | ) | `[inline]`

For internal use.

Definition at line 148 of file MP_index.hpp.

flopc::MP_index_exp::MP_index_exp | ( | int | i = `0` | ) |

create an index expression from a constant integer.

flopc::MP_index_exp::MP_index_exp | ( | const Constant & | c | ) |

create an index expression from a Constant

flopc::MP_index_exp::MP_index_exp | ( | MP_index & | i | ) |

create an index expression from an MP_index.

flopc::MP_index_exp::MP_index_exp | ( | const SUBSETREF & | d | ) |

create an index expression from a SUBSETREF

Todo:
  internal? or explain?

flopc::MP_index_exp::MP_index_exp | ( | const MP_index_exp & | other | ) |

copy constructor from another MP_index_exp

virtual flopc::MP_index_exp::~MP_index_exp | ( |  | ) | `[inline, virtual]`

Definition at line 161 of file MP_index.hpp.

## Member Function Documentation

static const MP_index_exp& flopc::MP_index_exp::getEmpty | ( |  | ) | `[static]`

Return the unique empty expression.

## Member Data Documentation

MP_index_exp flopc::MP_index_exp::Empty`[static, private]`

Definition at line 165 of file MP_index.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Smi-0.93.1/FlopCpp/src/MP_index.hpp